/*
    Copyright (C) 2008  Colin Caprani - www.colincaprani.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// This is a program to estimate the machine epsilon...

// To determine the machine epsilon define a=1+2^(-POW) and b=a-1
// macine epsilon is the smallest value of 2^(-POW) for which b != 0

#include <iostream>
#include <math.h>
using namespace std;

void main()
{
	double a; double b;
	int POW;
	int iEps;

/*	for(POW = 1; POW <= 60; POW++)
	{
		a = 1.0 + pow(2,-1*POW);
		b = a - 1.0;
		if(b>0.0)
			cout << "For 2^(-" << POW << ") b = " << b << endl;
		else
			cout << "For 2^(-" << POW << ") b = 0" << endl;
	}

	cout << "Epsilon is given by the smallest value of b" << endl;
*/

	cout << endl;
	cout << "************ CAPRANI VERSION ************" << endl;
	cout << endl;
	POW = 0;
	cout.precision(32);
	do
	{
		POW++;
		a = 1.0 + pow(2,-1*POW);
		b = a - 1.0;
		cout << "a: " << a << "\tb: " << b << endl;
	}while(b > 0);

	iEps= POW - 1;
	b = pow(2,-1*iEps);
	cout << "Lowest occurs at POW: " << iEps << endl;
	cout << "Epsilon is: " << b << endl;
	cout << "Numerical differentiation delX is: " << 0.5*sqrt(b) << endl << endl;
	cout << "*****************************************" << endl;

}